@echo off
SETLOCAL ENABLEDELAYEDEXPANSION
IF "%1" == "" GOTO usage
SET USERAGENT="Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.16) Gecko/20110319 Firefox/3.6.16 (.NET CLR 3.5.30729)"

SET id=%1%
IF "%id:~0,1%" == "-" SET id=%id:~1,4% 

SET id1=%id:~0,1%
SET id2=%id:~1,1%
SET id3=%id:~2,1%

IF EXIST "%id1%" GOTO n1
echo first id for %id1%
mkdir %id1%

:n1
IF EXIST "%id1%\%id2%" GOTO n2
echo first id for %id1%\%id2%
mkdir %id1%\%id2%

:n2
IF EXIST "%id1%\%id2%\%id3%" GOTO n3
echo first id for %id1%\%id2%\%id3%
mkdir %id1%\%id2%\%id3%
:n3

IF "%2" == "subsonly" GOTO subs

IF NOT EXIST "%id1%\%id2%\%id3%\%1\%1.flv" GOTO continue
IF EXIST "%id1%\%id2%\%id3%\%1\%1.flv.aria2" GOTO continue2
echo This file (%1) was already downloaded
goto end

:continue
mkdir %id1%\%id2%\%id3%\%1\

aria2c -o "%id1%\%id2%\%id3%\%1\%1.html" -U=%USERAGENT% "http://video.google.com/videoplay?docid=%1"
IF %ERRORLEVEL% NEQ 0 goto error

:continue2
echo downloading ID %1
IF EXIST ytdl del ytdl
youtube-dl.py -g http://video.google.com/videoplay?docid=%1 > ytdl
IF %ERRORLEVEL% NEQ 0 goto error

FOR /F %%H in (ytdl) DO (aria2c -U=%USERAGENT% --max-overall-download-limit=90M --file-allocation=none --max-connection-per-server=16 --min-split-size=1M --log-level=notice --retry-wait=1 --remote-time=true -o "%id1%\%id2%\%id3%\%1\%1.flv" %%H  
IF !ERRORLEVEL! NEQ 0 goto error
)

:subs

IF NOT EXIST %id1%\%id2%\%id3%\%1\ mkdir %id1%\%id2%\%id3%\%1\

echo getting subtitle list
IF EXIST subs.xml DEL subs.xml
aria2c -U="Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.16) Gecko/20110319 Firefox/3.6.16 (.NET CLR 3.5.30729)" -o %id1%\%id2%\%id3%\%1\%1.xml "http://video.google.com/videotranscript?docid=%1&type=list"
IF %ERRORLEVEL% NEQ 0 goto s_error;
type %id1%\%id2%\%id3%\%1\%1.xml
echo.
parse %id1%\%id2%\%id3%\%1\%1.xml
IF %ERRORLEVEL% NEQ 0 goto s_error;

FOR /F "tokens=1,2,3 delims=&" %%G in (xmlout) DO ( echo "http://video.google.com/videotranscript?docid=%1&type=track&name=%%H&lang=%%I"

aria2c -U=%USERAGENT% -o %id1%\%id2%\%id3%\%1\%1.%%G.xml "http://video.google.com/videotranscript?docid=%1&type=track&name=%%H&lang=%%I"
)
del xmlout
del xmltmp

goto end

:error
echo %1>> errors.txt
echo Error downloading ID %1
EXIT /B 1
goto erend:

:usage
echo usage %0 [id]
goto end
:s_error
echo there are no subtitles for this video

:end
EXIT /B 0
:erend